Foreman - Bug #11255

Cloning host with host group throws error: undefined method '[]' for nil:NilClass
07/30/2015 06:50 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Shimon Shtein
Category: Host creation
Target version: 1.10.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2597
Description

Since #9591, when cloning a host with a host group associated, you get the following error:

| ActionView::Template::Error (undefined method " []' for nil:NilClass):

| 60: <div id="compute_profile" <%= display? (!@host.compute_resource_id) %> >

| 6l: <%= select_f f, :compute_profile_id, ComputeProfile.visibles, :id, :name,

| 62: { :disable_button => _ (HostsAndHostgroupsHelper::INHERIT_TEXT),

\ 63: :disable_button_enabled => (@host.hostgroup && @host.hostgroup_id_was.nil?
&& !params|[:host] [:compute_profile_id],

| 64 : :user_set => params|[:host] && params|[:host] [:compute_profile_id]

| 65: bo

| 66: { :label => _ ("Compute profile"), :'data-url' => compute_resource_selected_

hosts_path,

| app/views/hosts/_form.html.erb:63:in “block (2 levels) in _app_views_hosts_ form_html_erb__ 2
877621245529704098_63524720"

| app/helpers/layout_helper.rb:321:in " form_for'

| app/views/hosts/_form.html.erb:8:in ‘block in _app_views_hosts__ form_html_erb__ 2877621245529
704098_63524720"

| app/models/taxonomy.rb:66:in “block (2 levels) in as_taxonomy'

| app/models/concerns/foreman/thread_session.rb:147:in “as_location'

| app/models/taxonomy.rb:65:in “block in as_taxonomy'

| app/models/concerns/foreman/thread_session.rb:112:in “as_org'

| app/models/taxonomy.rb:64:in " as_taxonomy'

| app/views/hosts/_form.html.erb:6:in ' _app_views_hosts_ form_html_erb_ 2877621245529704098_63
524720"

| app/views/hosts/clone.html.erb:3:in ' _app_views_hosts_clone_html_erb_ 3090041382908852687_640
38100"

| app/controllers/concerns/application_shared.rb:13:in "set_timezone'

| app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'

| lib/middleware/catch_json_parse_errors.rb:9:in “call'

There are a few accesses to nested parameters that won't have been passed in yet (e.g. params[:host][:compute_profile_id]) which
don't check that params[:host] is trueish. This only happens when a host group is associated as there's a preceding check for
@host.hostgroup.

Related issues:
Related to Foreman - Bug #9591: Override puppet configuration on host level d... Closed 03/01/2015

Associated revisions

Revision 5081efd9 - 08/13/2015 07:20 AM - Shimon Shtein

Fixes #11255 - Fixed inheritance checks for explicit input on host clone

History

#1 - 07/30/2015 06:50 AM - Dominic Cleal
https://projects.theforeman.org/issues/9591

- Related to Bug #9591: Override puppet configuration on host level does not work if specified on host group added

#2 - 07/30/2015 07:00 AM - Shimon Shtein

- Assignee set to Shimon Shtein

#3 - 08/09/2015 07:37 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2597 added
- Pull request deleted ()

#4 - 08/13/2015 08:01 AM - Shimon Shtein
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 5081efd962edecfa931367ef239689a5023e05¢6.
